<template>
    <q-page class="q-pa-md">
        <q-card class="q-pa-md" style="max-width: 600px; margin: 0 auto;">
            <q-card-section>
                <div class="text-h5">Manage Project Members</div>
            </q-card-section>

            <q-form @submit.prevent="handleSubmit">
                <!-- Admin Dashboard Password -->
                <q-input v-model="adminDashboardPassword" label="Admin Dashboard Password" type="password"
                    class="q-mb-md" required />

                <!-- Project Name -->
                <q-input v-model="projectName" label="Project Name" class="q-mb-md" required />

                <!-- Username to Add or Remove -->
                <q-input v-model="username" label="Username" class="q-mb-md" required />

                <!-- Action (Add or Remove) -->
                <q-select v-model="action" :options="actionOptions" label="Action" class="q-mb-md" required emit-value
                    map-options option-value="value" option-label="label" />

                <!-- Submit -->
                <q-btn label="Submit" color="primary" type="submit" />
            </q-form>

            <q-card-section v-if="resultMessage" class="q-mt-md">
                <q-banner :inline-actions="false" type="info">
                    {{ resultMessage }}
                </q-banner>
            </q-card-section>
        </q-card>
    </q-page>
</template>

<script setup>
import { ref } from 'vue';
import { useProjects } from 'src/hooks/projects';

// Data references
const adminDashboardPassword = ref('');
const projectName = ref('');
const username = ref('');
const action = ref('add');
const resultMessage = ref('');
const { error, addUserToProject, removeUserFromProject } = useProjects();
// The user can pick "add" or "remove"
const actionOptions = [
    { label: 'Add user', value: 'add' },
    { label: 'Remove user', value: 'remove' }
];

async function handleSubmit() {
    console.log('Action ref object:', action);    // Shows Proxy { <target>: {...}, <handler>: {...} }
    console.log('Action actual value:', action.value);
    try {
        if (action.value === 'add') {
            await addUserToProject({
                admin_dashboard_password: adminDashboardPassword.value,
                project: projectName.value,
                username: username.value
            });
        } else {
            await removeUserFromProject(
                {
                    admin_dashboard_password: adminDashboardPassword.value,
                    project: projectName.value,
                    username: username.value
                }
            );
        }
        if (!error.value) {
            // If request is successful, show a success message
            resultMessage.value = `User ${username.value} was successfully updated in project ${projectName.value}`;
        }





    } catch (error) {
        // If request fails, show an error
        resultMessage.value = error.response?.data?.error || error.message;
    }
}
</script>

<style scoped></style>